

#ifndef SHARED_H
#define SHARED_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <signal.h>

#define MAXREPLYSIZE 128

/*Defines boolean data type*/
typedef enum{FALSE = 0, TRUE} boolean;

#define TIME 0
#define TIME_ELAPSED 1
#define DISCONNECT 2
struct timeRequest{
  int replyMemorySegmentID_int;
  int replyNotificationSemaphore_int;
  unsigned int clientID;
  short reqType; /*Should be TIME, TIME_ELAPSED or DISCONNECT, type short for network compatibility*/
};

#define REQUESTSIZE  sizeof(struct timeRequest)
typedef void SignalHandlingFunction(int); /*From Stevens p.271*/

/*
WriteError
task: print a string to standard error
input: toReport_sz: string to display
output: -1 on error, 0 otherwise
*/
int WriteError(char *toReport_sz);

/*
 Makes sure that the output is atomic, wheter we are redirecting to a file or whatever
*/
int ensureStandardOutputAtomicity();
/*
Make the process sleep for the number of milliseconds defined
*/
void sleepALittle(long milliseconds);

/*
Sets handler for terminating signals
*/
int setSignalHandlerForTerminatingSignals(struct sigaction settings_sigaction);
#endif
