/*
Basic Protocol:
Server:
  -Server, when ready, signals semaphore SERVER_READY_SEMAPHORE
  -Server loops and checks semaphore CLIENT_PUT_REQUEST and waits on it when its set.
    The server also checks semaphore SERVER_READY_SEMAPHORE. If waited, but no CLIENT_PUT_REQUEST
    signaled in 10 seconds, we assume the client to be disfunctional and return to step 1.
  -Server finds relevent information, writes it on client's shared memory segment
  -Server signals semaphore SERVER_REQUEST_SERVICED
  -Return to step 1

  Should server check for a timeout and kill the IPC then?

Client:
  -Client waits semaphore SERVER_READY_SEMAPHORE
  -Clients puts request on on server's shared memory segment
  -Client signals semaphore CLIENT_PUT_REQUEST
  -Client waits on semaphore SERVER_REQUEST_SERVICED
  -Client fetches the data from the shared memory segment and does whatever it needs to to.

  clients should have a onexit set so that IPC structures are cleared

*/

#ifndef IPC_SHARED_H
#define IPC_SHARED_H
#include <sys/types.h>


#if defined(SEM_R) && defined (SEM_A)
  #define IPC_CONNECT_FLAG (SEM_R>>6) | (SEM_A>>6)
#else
  #define IPC_CONNECT_FLAG 0644
/*As defined in LDP http://www.redhat.com/mirrors/LDP/LDP/lpg/node51.html*/
#endif

#define IPC_CREATION_FLAG IPC_CONNECT_FLAG|IPC_CREAT

const key_t SERVER_SEMAPHORES_KEY  = 2020;
const key_t SERVER_SHARED_MEMORY_KEY =2021;
const short NUM_SERVER_SEMAPHORES = 2; /*Ensure that this value remains consistent with the definitions below*/
const short SERVER_READY = 0; /*Index of that semaphore in the semaphore array*/
const short REQUEST_FORWARDED_NOTIFICATION = 1; /*Index of that semaphore in the semaphore array*/

#endif

