#ifndef TCP_COMMON_H
#define TCP_COMMON_H

/*Default port for the server*/
#define SERVERPORT 2020

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>

/*
function setSocketParams
task: set TCP_NODELAY option on sockets
input: none
output: -1 on error, 0 otherwise
*/
int setSocketParams(int socketToSet_int){
/*from http://www.ibrado.com/sock-faq/#faq22
and
http://archives.postgresql.org/pgsql-ports/2000-10/msg00018.php
*/
  int flag = 1;
  /*set TCP_NODELAY*/
  int result = setsockopt(socketToSet_int,            /* socket affected */
                          IPPROTO_TCP,     /* set option at TCP level */
                          TCP_NODELAY,     /* name of option */
                          (char *) &flag,  /* the cast is historical
                                                  cruft */
                          sizeof(int));    /* length of option value */
  if (result < 0) return -1; else return 0;
}

#endif

